/*
   Beta release 
   It's actually starting to work, major annoyances have been fixed
   Read the README :)

   -- Scrippie
*/

#include <ctype.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <unistd.h>
#include "smegma.h"

extern int lineno;
extern struct tokstruct token;
extern FILE *input;

int main(int argc, char **argv)
{
   char shellcode[MAXSCSIZE] = "";		/* Who needs longer stuff? */
   char *machinecode;
   char *modifiedcode;
   size_t r, binSCsize;

   if(argc != 4) {			/* Check arguments */
      banner(argv[0]);
      exit(-1);
   }

   if(!(input = fopen(argv[1], "r"))) {
      perror("fopen()");
      exit(-1);
   }

   lexInit();				/* Initialize the lexer */

   do {
      lexAnalyze();			/* Go and find the shellcode */
      if(token.id == STRINGID && isShellcode(token.val)) {
         strncpy(shellcode, token.val, MAXSCSIZE-1);
         break;
      }
   } while (token.id != 0);

   if(shellcode[0] == 0x00) {
      printf("No shellcode found...\n");
      exit(0);
   }

   printf("Shellcode:\n%s\n", shellcode);
   machinecode = asciiSCToBin(shellcode, &binSCsize);
   printf("Size: %d\n\n", binSCsize);

   switch(atoi(argv[2])) {
      case 1:
         printf("Using byte xorring...\n");
         modifiedcode = (char *) memcrypt(machinecode, XOR_BYTE,
            strtoul(argv[3], NULL, 16), binSCsize, &r);
         break;
      case 2:
         printf("Using word xorring...\n");
         modifiedcode = (char *) memcrypt(machinecode, XOR_WORD,
            strtoul(argv[3], NULL, 16), binSCsize, &r);
         break;
      case 3:
         printf("Using dword xorring...\n");
         modifiedcode = (char *) memcrypt(machinecode, XOR_DWORD,
           strtoul(argv[3], NULL, 16), binSCsize, &r);
         break;
      case 4:
         printf("Using byte addition...\n");
         modifiedcode = (char *) memcrypt(machinecode, ADD_BYTE,
           strtoul(argv[3], NULL, 16), binSCsize, &r);
         break;
      case 5:
         printf("Using word addition...\n");
         modifiedcode = (char *) memcrypt(machinecode, ADD_WORD,
           strtoul(argv[3], NULL, 16), binSCsize, &r);
         break;
      case 6:
         printf("Using dword addition...\n");
         modifiedcode = (char *) memcrypt(machinecode, ADD_DWORD,
            strtoul(argv[3], NULL, 16), binSCsize, &r);
         break;
      case 7:
         printf("Using UUencoding...\n");
         modifiedcode = (char *) memcrypt(machinecode, UUDECODE,
           strtoul(argv[3], NULL, 16), binSCsize, &r);
         break;
      default:
         printf("Unknown type...\n");
         exit(-1);
   } 

   printf("Size: %d\n",r);
   printf("%s\n", binSCToAscii(modifiedcode, r));

   printf("\nNumber of lines analyzed: %d\n", lineno+1);
   exit(0);
}

/*
   Converts shellcode in binary form (ie. machine code) to an ASCII
   \x[0-9a-f]{2} representation.
*/

char *binSCToAscii(void *input, size_t size)
{
   int i;
   char c;
   char *output;

   if(!(output = (char *)malloc(size*4+1))) return NULL;

   for(i=0;i<size;i++) {	/* For every char in input */
      c = ((char *)input)[i];	/* Convert to long and put in c */
      sprintf(output+4*i, "\\x%.2x",c & 0xff);	/* Convert this character */
   }

   return(output);
}

/*
   Converts shellcode in ASCII \x[0-9a-fA-F]{1,2} notation to it's binary
   form.
*/

void *asciiSCToBin(char *input, size_t *retsize)
{
   int i=0;
   int len = strlen(input);
   char *hexedSC;
   char *tmp;

   if(!(hexedSC = (char *) malloc(len/2+1))) {
      perror("malloc()");
      fprintf(stderr, "Not enough memory to complete error messa\n");
      exit(-1);
   }

   /* I don't agree with everything the man pages tell me
      strtok() kicks ass and is ANSI C while strsep() is not
   */

   if(!(tmp = (char *) strtok(input, "\\x"))) return NULL;

   do {
      sprintf(hexedSC+i,"%c",((char) strtoul(tmp, NULL, 16) & 0xff));
      i++;
   } while((tmp = (char *) strtok(NULL, "\\x")));

   *retsize = (size_t) i;

   return hexedSC;
}

/*
   Recognizes (\\x[0-9A-Fa-f]{1,2})+ as valid shellcode
*/

int isShellcode(char *gerrieSux)
{
   unsigned int i;
   size_t len = strlen(gerrieSux);

   if(!gerrieSux || len<3) return -1;	/* Sanity check ;) */

   for(i=0;i<len;) {
      if(gerrieSux[i++] != '\\' || gerrieSux[i++] != 'x') return(0);
      else if(!isxdigit(gerrieSux[i++])) return(0);
      if(isxdigit(gerrieSux[i])) i++;
   }
   return(1);
}

void banner(char viperIsAnIdiotToo[])  /* This looks so darn funny in the
                                          symbol table ;) */
{
   int which;

   srand(time(NULL));

   which=1+(int) (2.0*rand()/(RAND_MAX+1.0));

   printf("/-#-#-#-#-#-#-#-#-#-#-#-#-#-#-#-#-#-#-#-#-#-\\\n");
   printf("| ShellCode Mutation Engine -- Version %s |\n", VERSION);
   printf("\\-#-#-#-#-#-#-#-#-#-#-#-#-#-#-#-#-#-#-#-#-#-/\n");
   printf("+           Presented to you by             +\n");
   printf("+                                           +\n");
   printf("+                Scrippie                   +\n");

   if(which == 1) {
      printf("+         Buffer0verfl0w Security           +\n");
      printf("+               #Phreak.nl                  +\n");
   }
   else {
      printf("+               #Phreak.nl                  +\n");
      printf("+         Buffer0verfl0w Security           +\n");
   }

   /* 
      Faul is fair and fair is faul
      No people feeling unhappy because of
      the others name being mentioned first ;)
   */
   printf("+++++++++++++++++++++++++++++++++++++++++++++\n");
   printf("Use as: %s <exploit.c> <type> <mask>\n", viperIsAnIdiotToo);
   printf("Type can be the following:\n\n");
   printf("\t%.12s\t%.12s\t%.12s\n", "1) Byte Xor", "4) Byte Add",
                                     "7) Uudecode");
   printf("\t%.12s\t%.12s\n", "2) Word Xor", "5) Word Add");
   printf("\t%.12s\t%.12s\n", "3) Dword Xor", "6) Dword Add");
}
